diff --git a/amdmsr.h b/amdmsr.h
index 8c1ae30b..8e15bce7 100644
--- a/amdmsr.h
+++ b/amdmsr.h
@@ -54,19 +54,6 @@
 	#define MSR_AMD_PP0_ENERGY_STATUS	0xc001029a
 #endif
 
-/* UNDOCUMENTED REGISTERS */
-#ifndef MSR_AMD_PC6_F17H_STATUS
-	#define MSR_AMD_PC6_F17H_STATUS		0xc0010292
-#endif
-
-#ifndef MSR_AMD_PSTATE_F17H_BOOST
-	#define MSR_AMD_PSTATE_F17H_BOOST	0xc0010293
-#endif
-
-#ifndef MSR_AMD_CC6_F17H_STATUS
-	#define MSR_AMD_CC6_F17H_STATUS 	0xc0010296
-#endif
-
 /* Sources: BKDG for AMD Family 0Fh,15_00h-15_0Fh,15_10h-15_1Fh,15_30-15_3Fh */
 #define PCI_AMD_TEMPERATURE_TCTL	PCI_CONFIG_ADDRESS(0, 0x18, 0x3, 0xa4)
 #define PCI_AMD_THERMTRIP_STATUS	PCI_CONFIG_ADDRESS(0, 0x18, 0x3, 0xe4)
@@ -90,6 +77,15 @@
 #define SMU_AMD_INDEX_REGISTER_F16H	PCI_CONFIG_ADDRESS(0, 0, 0, 0x60)
 #define SMU_AMD_DATA_REGISTER_F16H	PCI_CONFIG_ADDRESS(0, 0, 0, 0x64)
 
+#define Core_AMD_SMN_Read(Core ,	SMN_Register,			\
+					SMN_Address,			\
+					SMU_IndexRegister,		\
+					SMU_DataRegister)		\
+({									\
+	WRPCI(SMN_Address, SMU_IndexRegister);				\
+	RDPCI(SMN_Register.value, SMU_DataRegister);			\
+})
+
 /* Sources:
  * BKDG for AMD Family [15_60h - 15_70h]
 	D0F0xBC_xD820_0CA4 Reported Temperature Control
@@ -100,6 +96,35 @@
 #define SMU_AMD_THM_TCTL_REGISTER_F15H		0xd8200ca4
 #define SMU_AMD_THM_TCTL_REGISTER_F17H		0x00059800
 
+/* UNDOCUMENTED REGISTERS */
+#ifndef MSR_AMD_PC6_F17H_STATUS
+	#define MSR_AMD_PC6_F17H_STATUS 	0xc0010292
+#endif
+
+#ifndef MSR_AMD_PSTATE_F17H_BOOST
+	#define MSR_AMD_PSTATE_F17H_BOOST	0xc0010293
+#endif
+
+#ifndef MSR_AMD_CC6_F17H_STATUS
+	#define MSR_AMD_CC6_F17H_STATUS 	0xc0010296
+#endif
+
+/* Sources: drivers/edac/amd64_edac.h					*/
+#ifndef SMU_AMD_UMC_BASE_CH0_F17H
+	#define SMU_AMD_UMC_BASE_CH0_F17H	0x00050000
+#endif
+
+#ifndef SMU_AMD_UMC_BASE_CH1_F17H
+	#define SMU_AMD_UMC_BASE_CH1_F17H	0x00150000
+#endif
+/* Sources: drivers/edac/amd64_edac.c					*/
+#define UMCCH_DIMM_CFG			0x80
+#define UMCCH_UMC_CFG			0x100
+#define UMCCH_SDP_CTRL			0x104
+#define UMCCH_ECC_CTRL			0x14C
+#define UMCCH_UMC_CAP			0xDF0
+#define UMCCH_UMC_CAP_HI		0xDF4
+
 
 const struct {
 	unsigned int	MCF,
@@ -577,17 +602,21 @@ typedef union
 	};
 } AMD_0F_HTT_FREQUENCY;
 
-typedef struct
+typedef union
 {
-	unsigned int
-	PerStepTimeUp	:  5-0,  /* Family: 12h, 14h, 15h		*/
-	TmpMaxDiffUp	:  7-5,  /* Family: 12h, 14h, 15h		*/
-	TmpSlewDnEn	:  8-7,  /* Family: 12h, 14h, 15h		*/
-	PerStepTimeDn	: 13-8,  /* Family: 12h, 14h, 15h		*/
-	ReservedBits1	: 16-13,
-	CurTempTJselect : 18-16, /* Family: 15h				*/
-	ReservedBits2	: 21-18,
-	CurTmp		: 32-21; /* Family: 12h, 14h, 15h, 17h		*/
+	unsigned int		value;
+	struct
+	{
+		unsigned int
+		PerStepTimeUp	:  5-0,  /* Family: 12h, 14h, 15h	*/
+		TmpMaxDiffUp	:  7-5,  /* Family: 12h, 14h, 15h	*/
+		TmpSlewDnEn	:  8-7,  /* Family: 12h, 14h, 15h	*/
+		PerStepTimeDn	: 13-8,  /* Family: 12h, 14h, 15h	*/
+		ReservedBits1	: 16-13,
+		CurTempTJselect : 18-16, /* Family: 15h			*/
+		ReservedBits2	: 21-18,
+		CurTmp		: 32-21; /* Family: 12h, 14h, 15h, 17h	*/
+	};
 } TCTL_REGISTER;
 
 typedef struct
diff --git a/corefreqk.c b/corefreqk.c
index f548d19b..2b2af2c6 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -5145,6 +5145,111 @@ static void PerCore_AMD_Family_17h_Query(void *arg)
 	Query_AMD_Zen(Core);
 
 	Core->PowerThermal.Param = Arch[Proc->ArchID].Specific[0].Param;
+
+    if (Proc->Registration.Experimental)
+    {
+	union
+	{
+		unsigned int	value;
+	} TestRegister = {.value = 0};
+	/* Channel 0							*/
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH0_F17H + UMCCH_DIMM_CFG,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[0] UMCCH_DIMM_CFG[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH0_F17H + UMCCH_UMC_CFG,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[0] UMCCH_UMC_CFG[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH0_F17H + UMCCH_SDP_CTRL,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[0] UMCCH_SDP_CTRL[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH0_F17H + UMCCH_ECC_CTRL,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[0] UMCCH_ECC_CTRL[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH0_F17H + UMCCH_UMC_CAP,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[0] UMCCH_UMC_CAP[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH0_F17H + UMCCH_UMC_CAP_HI,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[0] UMCCH_UMC_CAP_HI[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	/* Channel 1							*/
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH1_F17H + UMCCH_DIMM_CFG,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[1] UMCCH_DIMM_CFG[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH1_F17H + UMCCH_UMC_CFG,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[1] UMCCH_UMC_CFG[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH1_F17H + UMCCH_SDP_CTRL,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[1] UMCCH_SDP_CTRL[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH1_F17H + UMCCH_ECC_CTRL,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[1] UMCCH_ECC_CTRL[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH1_F17H + UMCCH_UMC_CAP,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[1] UMCCH_UMC_CAP[%u]\n",
+		Core->Bind, TestRegister.value);
+
+	Core_AMD_SMN_Read(Core, TestRegister,
+				SMU_AMD_UMC_BASE_CH1_F17H + UMCCH_UMC_CAP_HI,
+				SMU_AMD_INDEX_REGISTER_F16H,
+				SMU_AMD_DATA_REGISTER_F16H);
+
+	printk("TEST: Core[%u] Channel[1] UMCCH_UMC_CAP_HI[%u]\n",
+		Core->Bind, TestRegister.value);
+    }
 }
 
 #if LINUX_VERSION_CODE < KERNEL_VERSION(3, 10, 56)
@@ -6001,26 +6106,19 @@ void Core_AMD_Family_15h_Temp(CORE *Core)
 	}
 }
 
-#define Core_AMD_SMU_Thermal(Core,	TctlRegister,			\
-					SMU_IndexRegister,		\
-					SMU_DataRegister)		\
-({									\
-	TCTL_REGISTER TctlSensor = {0};					\
-									\
-	WRPCI(TctlRegister, SMU_IndexRegister) ;			\
-	RDPCI(TctlSensor, SMU_DataRegister);				\
-									\
-	Core->PowerThermal.Sensor = TctlSensor.CurTmp;			\
-})
-
-/*TODO:	Bulldozer/Excavator [need hardware to test with]
+/*TODO: Bulldozer/Excavator [need hardware to test with]
 void Core_AMD_Family_15_60h_Temp(CORE *Core)
 {
     if (Proc->Registration.Experimental) {
-	Core_AMD_SMU_Thermal(Core,	SMU_AMD_THM_TCTL_REGISTER_F15H,
+	TCTL_REGISTER TctlSensor = {.value = 0};
+
+	Core_AMD_SMN_Read(Core ,	TctlSensor,
+					SMU_AMD_THM_TCTL_REGISTER_F15H,
 					SMU_AMD_INDEX_REGISTER_F15H,
 					SMU_AMD_DATA_REGISTER_F15H);
 
+	Core->PowerThermal.Sensor = TctlSensor.CurTmp;
+
 	if (Proc->Features.AdvPower.EDX.TTP == 1) {
 		THERMTRIP_STATUS ThermTrip = {0};
 
@@ -6036,9 +6134,14 @@ void Core_AMD_Family_15_60h_Temp(CORE *Core)
 
 void Core_AMD_Family_17h_Temp(CORE *Core)
 {
-	Core_AMD_SMU_Thermal(Core,	SMU_AMD_THM_TCTL_REGISTER_F17H,
+	TCTL_REGISTER TctlSensor = {.value = 0};
+
+	Core_AMD_SMN_Read(Core ,	TctlSensor,
+					SMU_AMD_THM_TCTL_REGISTER_F17H,
 					SMU_AMD_INDEX_REGISTER_F16H,
 					SMU_AMD_DATA_REGISTER_F16H);
+
+	Core->PowerThermal.Sensor = TctlSensor.CurTmp;
 }
 
 static enum hrtimer_restart Cycle_GenuineIntel(struct hrtimer *pTimer)
diff --git a/coretypes.h b/coretypes.h
index d3162432..5790ba2f 100644
--- a/coretypes.h
+++ b/coretypes.h
@@ -4,7 +4,7 @@
  * Licenses: GPL2
  */
 
-#define COREFREQ_VERSION	"1.54.5"
+#define COREFREQ_VERSION	"1.55.0"
 
 enum {	GenuineIntel,
 	Core_Yonah,
